searchNodes=[{"doc":"Rummage.Ecto is a light weight, but powerful framework that can be used to alter Ecto queries with Search, Sort and Paginate operations.It accomplishes the above operations by using Hooks, which are modules that implement Rummage.Ecto.Hook behavior. Each operation: Search, Sort and Paginate have their hooks defined in Rummage. By doing this, we have made rummage completely configurable. For example, if you don't like one of the implementations of Rummage, but like the other two, you can configure Rummage to not use it.If you want to check a sample application that uses Rummage, please check this link.Usage:defmodule Rummage.Ecto.Category do use Ecto.Schema use Rummage.Ecto schema &quot;categories&quot; do field :name, :string end endThis allows you to do:iex&gt; rummage = %{search: %{name: %{assoc: [], search_type: :ilike, search_term: &quot;field_!&quot;}}} iex&gt; {queryable, rummage} = Rummage.Ecto.Category.rummageq(Rummage.Ecto.Category, rummage) iex&gt; queryable #Ecto.Query&lt;from c0 in subquery(from c0 in Rummage.Ecto.Category), where: ilike(c0.name, ^&quot;%field_!%&quot;)&gt; iex&gt; rummage %{search: %{name: %{assoc: [], search_expr: :where, search_term: &quot;field_!&quot;, search_type: :ilike}}}This also allows you to do call rummage/2 without a queryable which defaults to the module calling rummage, which is Rummage.Ecto.Category in this case:iex&gt; rummage = %{search: %{name: %{assoc: [], search_type: :ilike, search_term: &quot;field_!&quot;}}} iex&gt; {queryable, rummage} = Rummage.Ecto.Category.rummage(rummage) iex&gt; queryable #Ecto.Query&lt;from c0 in subquery(from c0 in Rummage.Ecto.Category), where: ilike(c0.name, ^&quot;%field_!%&quot;)&gt; iex&gt; rummage %{search: %{name: %{assoc: [], search_expr: :where, search_term: &quot;field_!&quot;, search_type: :ilike}}}","ref":"Rummage.Ecto.html","title":"Rummage.Ecto","type":"module"},{"doc":"This macro allows an Ecto.Schema to leverage rummage's features with ease. This macro defines a function rummage/2 which can be called on the Module using this which delegates to Rummage.Ecto.rummage/3, but before doing that it resolves the options with default values for repo, search hook, sort hook and paginate hook. If rummage/2 is called with those options in form of keys given to the last argument opts, then it sets those keys to what's given else it delegates it to the defaults specficied by __using__ macro. If no defaults are specified, then it further delegates it to configurations.The function rummage/2 takes in rummage params and opts and calls Rummage.Ecto.rummage/3 with whatever schema is calling it as the queryable.This macro also defines a function rummageq/3 where q implies queryable. Therefore this function can take a queryable as the first argument.In this way this macro makes it very easy to use Rummage.Ecto.Usage:Basic Usage where a default repo is specified as options to the macro.defmodule MyApp.MySchema do use Ecto.Schema use Rummage.Ecto, repo: MyApp.Repo, per_page: 10 endAdvanced Usage where search and sort hooks are overrident for this module.defmodule MyApp.MySchema do use Ecto.Schema use Rummage.Ecto, repo: MyApp.Repo, per_page: 10, search: CustomSearchModule, sort: CustomSortModule end This allows you do just do `MyApp.Schema.rummage(rummage_params)` with specific `rummage_params` and add `Rummage.Ecto`&#39;s power to your schema.","ref":"Rummage.Ecto.html#__using__/1","title":"Rummage.Ecto.__using__/1","type":"macro"},{"doc":"This is the function which calls to the Rummage hooks. It is the entry-point to Rummage.Ecto.This function takes in a queryable, a rummage map and an opts keyword. Recognized opts keys are:repo: If you haven't set up a repo at the config level or __using__ level, this a way of passing `repo` to `rummage`. If you have already configured your app to use a default `repo` and/or specified the `repo` at `__using__` level, this is a way of overriding those defaults.per_page: If you haven't set up a per_page at the config level or __using__ level, this a way of passing `per_page` to `rummage`. If you have already configured your app to use a default `per_page` and/or specified the `per_page` at `__using__` level, this is a way of overriding those defaults.search: If you haven't set up a search at the config level or __using__ level, this a way of passing `search` to `rummage`. If you have already configured your app to use a default `search` and/or specified the `search` at `__using__` level, this is a way of overriding those defaults. This can be used to override native `Rummage.Ecto.Hook.Search` to a custom hook.sort: If you haven't set up a sort at the config level or __using__ level, this a way of passing `sort` to `rummage`. If you have already configured your app to use a default `sort` and/or specified the `sort` at `__using__` level, this is a way of overriding those defaults. This can be used to override native `Rummage.Ecto.Hook.Sort` to a custom hook.paginate: If you haven't set up a paginate at the config level or __using__ level, this a way of passing `paginate` to `rummage`. If you have already configured your app to use a default `paginate` and/or specified the `paginate` at `__using__` level, this is a way of overriding those defaults. This can be used to override native `Rummage.Ecto.Hook.Paginate` to a custom hook.ExamplesWhen no hook params are given, it just returns the queryable and the params:iex&gt; import Rummage.Ecto iex&gt; alias Rummage.Ecto.Product iex&gt; rummage = %{} iex&gt; {queryable, rummage} = rummage(Product, rummage) iex&gt; rummage %{} iex&gt; queryable Rummage.Ecto.ProductWhen nil hook module is given, it just returns the queryable and the params:iex&gt; import Rummage.Ecto iex&gt; alias Rummage.Ecto.Product iex&gt; rummage = %{paginate: %{page: 1}} iex&gt; {queryable, rummage} = rummage(Product, rummage, paginate: nil) iex&gt; rummage %{paginate: %{page: 1}} iex&gt; queryable Rummage.Ecto.ProductWhen a hook param is given, with hook module it just returns the queryable and the params:iex&gt; import Rummage.Ecto iex&gt; alias Rummage.Ecto.Product iex&gt; rummage = %{paginate: %{page: 1}} iex&gt; repo = Rummage.Ecto.Repo iex&gt; Ecto.Adapters.SQL.Sandbox.checkout(repo) iex&gt; opts = [paginate: Rummage.Ecto.Hook.Paginate, repo: repo] iex&gt; {queryable, rummage} = rummage(Product, rummage, opts) iex&gt; rummage %{paginate: %{max_page: 0, page: 1, per_page: 10, total_count: 0}} iex&gt; queryable #Ecto.Query&lt;from p0 in Rummage.Ecto.Product, limit: ^10, offset: ^0&gt;When a hook is given, with correspondng params, it updates and returns the queryable and the params accordingly:iex&gt; import Rummage.Ecto iex&gt; alias Rummage.Ecto.Product iex&gt; rummage = %{paginate: %{per_page: 1, page: 1}} iex&gt; repo = Rummage.Ecto.Repo iex&gt; Ecto.Adapters.SQL.Sandbox.checkout(repo) iex&gt; repo.insert!(%Product{name: &quot;name&quot;, internal_code: &quot;100&quot;}) iex&gt; repo.insert!(%Product{name: &quot;name2&quot;, internal_code: &quot;101&quot;}) iex&gt; opts = [paginate: Rummage.Ecto.Hook.Paginate, ...&gt; repo: repo] iex&gt; {queryable, rummage} = rummage(Product, rummage, opts) iex&gt; rummage %{paginate: %{max_page: 2, page: 1, per_page: 1, total_count: 2}} iex&gt; queryable #Ecto.Query&lt;from p0 in Rummage.Ecto.Product, limit: ^1, offset: ^0&gt;","ref":"Rummage.Ecto.html#rummage/3","title":"Rummage.Ecto.rummage/3","type":"function"},{"doc":"This module encapsulates all the Rummage's runtime configurations that can be set in the config.exs file.This configuration is optional, as Rummage.Ecto can accept the same arguments as optional arguments to the function Rummage.Ecto.rummage/3Usage:A basic example without overriding default hooks:config.exs: config :app_name, Rummage.Ecto,per_page: 10, repo: AppName.RepoThis is a more advanced usage where you can specify the default hooks:config.exs: config :app_name, Rummage.Ecto,per_page: 10, repo: AppName.Repo, search: Rummage.Ecto.Hook.Search, sort: Rummage.Ecto.Hook.Sort, paginate: Rummage.Ecto.Hook.Paginate","ref":"Rummage.Ecto.Config.html","title":"Rummage.Ecto.Config","type":"module"},{"doc":":paginate hook can also be set at run time in the config.exs fileExamplesWhen no config is set, if returns the default hook (Rummage.Ecto.Hook.Paginate):iex&gt; alias Rummage.Ecto.Config iex&gt; Config.paginate Rummage.Ecto.Hook.Paginate","ref":"Rummage.Ecto.Config.html#paginate/1","title":"Rummage.Ecto.Config.paginate/1","type":"function"},{"doc":":per_page can also be set at run time in the config.exs fileExamplesReturns default Repo set in the config (2 in rummage_ecto's test env):iex&gt; alias Rummage.Ecto.Config iex&gt; Config.per_page 2","ref":"Rummage.Ecto.Config.html#per_page/1","title":"Rummage.Ecto.Config.per_page/1","type":"function"},{"doc":":repo can also be set at run time in the config.exs fileExamplesReturns default Repo set in the config (Rummage.Ecto.Repo in rummage_ecto's test env):iex&gt; alias Rummage.Ecto.Config iex&gt; Config.repo Rummage.Ecto.Repo","ref":"Rummage.Ecto.Config.html#repo/1","title":"Rummage.Ecto.Config.repo/1","type":"function"},{"doc":":search hook can also be set at run time in the config.exs file. This pulls the configuration assocated with the application, application. When no application is given this defaults to rummage_ecto.ExamplesWhen no config is set, if returns the default hook (Rummage.Ecto.Hook.Search):iex&gt; alias Rummage.Ecto.Config iex&gt; Config.search Rummage.Ecto.Hook.Search","ref":"Rummage.Ecto.Config.html#search/1","title":"Rummage.Ecto.Config.search/1","type":"function"},{"doc":":sort hook can also be set at run time in the config.exs fileExamplesWhen no config is set, if returns the default hook (Rummage.Ecto.Hook.Sort):iex&gt; alias Rummage.Ecto.Config iex&gt; Config.sort Rummage.Ecto.Hook.Sort","ref":"Rummage.Ecto.Config.html#sort/1","title":"Rummage.Ecto.Config.sort/1","type":"function"},{"doc":"Rummage.Ecto.CustomHook.KeysetPaginate is an example of a Custom Hook that comes with Rummage.Ecto.This module uses keyset pagination to add a pagination query expression on top a given Ecto.Queryable.For more information on Keyset Pagination, check this articleNOTE: This module doesn't return a list of entries, but a Ecto.Query.t. This module uses Rummage.Ecto.Hook.ABOUT:Arguments:This Hook expects a queryable (an Ecto.Queryable) and paginate_params (a Map). The map should be in the format: %{per_page: 10, page: 1, last_seen_pk: 10, pk: :id}Details:per_page: Specifies the entries in each page.page: Specifies the page number.last_seen_pk: Specifies the primary_key value of last_seen entry, This hook uses this entry instead of offset.pk: Specifies what's the primary_key for the entries being paginated. Cannot be `nil`For example, if we want to paginate products (primary_key = :id), we would do the following:Rummage.Ecto.CustomHook.KeysetPaginate.run(Product, %{per_page: 10, page: 1, last_seen_pk: 10, pk: :id})When to Use KeysetPaginate?Keyset Pagination is mainly here to make pagination faster for complex pages. It is recommended that you use Rummage.Ecto.Hook.Paginate for a simple pagination operation, as this module has a lot of assumptions and it's own ordering on top of the given query.NOTE: It is not recommended to use this with the native sort hookASSUMPTIONS/NOTES:This Hook assumes that the querried Ecto.Schema has a primary_key.This Hook also orders the query by ascending primary_keyUSAGEalias Rummage.Ecto.CustomHook.KeysetPaginate queryable = KeysetPaginate.run(Parent, %{per_page: 10, page: 1, last_seen_pk: 10, pk: :id})This module can be used by overriding the default module. This can be done in the following ways:In the Rummage.Ecto call:Rummage.Ecto.rummage(queryable, rummage, paginate: Rummage.Ecto.CustomHook.KeysetPaginate)ORGlobally for all models in config.exs:config :my_app, Rummage.Ecto, paginate: Rummage.Ecto.CustomHook.KeysetPaginateORWhen using Rummage.Ecto with an Ecto.Schema:defmodule MySchema do use Rummage.Ecto, repo: SomeRepo, paginate: Rummage.Ecto.CustomHook.KeysetPaginate end","ref":"Rummage.Ecto.CustomHook.KeysetPaginate.html","title":"Rummage.Ecto.CustomHook.KeysetPaginate","type":"module"},{"doc":"Callback implementation for Rummage.Ecto.Hook.format_params/3.This function takes an Ecto.Query.t or queryable, paginate_params which will be passed to the run/2 function, but also takes a list of options, opts.The function expects opts to include a repo key which points to the Ecto.Repo which will be used to calculate the total_count and max_page for this paginate hook module.ExamplesWhen a repo isn't passed in opts it gives an error:iex&gt; alias Rummage.Ecto.CustomHook.KeysetPaginate iex&gt; alias Rummage.Ecto.Category iex&gt; KeysetPaginate.format_params(Category, %{per_page: 1, page: 1}, []) ** (RuntimeError) Expected key `repo` in `opts`, got []When paginate_params given aren't valid, it uses defaults to populate params:iex&gt; alias Rummage.Ecto.CustomHook.KeysetPaginate iex&gt; alias Rummage.Ecto.Category iex&gt; Ecto.Adapters.SQL.Sandbox.checkout(Rummage.Ecto.Repo) iex&gt; KeysetPaginate.format_params(Category, %{}, [repo: Rummage.Ecto.Repo]) %{max_page: 0, page: 1, per_page: 10, total_count: 0, pk: :id, last_seen_pk: 0}When paginate_params and opts given are valid:iex&gt; alias Rummage.Ecto.CustomHook.KeysetPaginate iex&gt; alias Rummage.Ecto.Category iex&gt; paginate_params = %{ ...&gt; per_page: 1, ...&gt; page: 1 ...&gt; } iex&gt; repo = Rummage.Ecto.Repo iex&gt; Ecto.Adapters.SQL.Sandbox.checkout(repo) iex&gt; KeysetPaginate.format_params(Category, paginate_params, [repo: repo]) %{max_page: 0, last_seen_pk: 0, page: 1, per_page: 1, total_count: 0, pk: :id}When paginate_params and opts given are valid:iex&gt; alias Rummage.Ecto.CustomHook.KeysetPaginate iex&gt; alias Rummage.Ecto.Category iex&gt; paginate_params = %{ ...&gt; per_page: 1, ...&gt; page: 1 ...&gt; } iex&gt; repo = Rummage.Ecto.Repo iex&gt; Ecto.Adapters.SQL.Sandbox.checkout(repo) iex&gt; repo.insert!(%Category{name: &quot;name&quot;}) iex&gt; repo.insert!(%Category{name: &quot;name2&quot;}) iex&gt; KeysetPaginate.format_params(Category, paginate_params, [repo: repo]) %{max_page: 2, last_seen_pk: 0, page: 1, per_page: 1, total_count: 2, pk: :id}When paginate_params and opts given are valid and when the queryable passed has a primary_key defaulted to id.iex&gt; alias Rummage.Ecto.CustomHook.KeysetPaginate iex&gt; alias Rummage.Ecto.Category iex&gt; paginate_params = %{ ...&gt; per_page: 1, ...&gt; page: 1 ...&gt; } iex&gt; repo = Rummage.Ecto.Repo iex&gt; Ecto.Adapters.SQL.Sandbox.checkout(repo) iex&gt; repo.insert!(%Category{name: &quot;name&quot;}) iex&gt; repo.insert!(%Category{name: &quot;name2&quot;}) iex&gt; KeysetPaginate.format_params(Category, paginate_params, [repo: repo]) %{max_page: 2, last_seen_pk: 0, page: 1, per_page: 1, total_count: 2, pk: :id}When paginate_params and opts given are valid and when the queryable passed has a custom primary_key.iex&gt; alias Rummage.Ecto.CustomHook.KeysetPaginate iex&gt; alias Rummage.Ecto.Product iex&gt; paginate_params = %{ ...&gt; per_page: 1, ...&gt; page: 2 ...&gt; } iex&gt; repo = Rummage.Ecto.Repo iex&gt; Ecto.Adapters.SQL.Sandbox.checkout(repo) iex&gt; repo.insert!(%Product{internal_code: &quot;100&quot;}) iex&gt; repo.insert!(%Product{internal_code: &quot;101&quot;}) iex&gt; KeysetPaginate.format_params(Product, paginate_params, [repo: repo]) %{max_page: 2, last_seen_pk: 1, page: 2, per_page: 1, total_count: 2, pk: :internal_code}","ref":"Rummage.Ecto.CustomHook.KeysetPaginate.html#format_params/3","title":"Rummage.Ecto.CustomHook.KeysetPaginate.format_params/3","type":"function"},{"doc":"This is the callback implementation of Rummage.Ecto.Hook.run/2.Builds a paginate Ecto.Query.t on top of a given Ecto.Query.t variable with given params.Besides an Ecto.Query.t an Ecto.Schema module can also be passed as it implements Ecto.QueryableParams is a Map which is expected to have the keys per_page, page, last_seen_pk, pk.If an expected key isn't given, a Runtime Error is raised.ExamplesWhen an empty map is passed as params:iex&gt; alias Rummage.Ecto.CustomHook.KeysetPaginate iex&gt; KeysetPaginate.run(Parent, %{}) ** (RuntimeError) Error in params, No values given for keys: per_page, page, last_seen_pk, pkWhen a non-empty map is passed as params, but with a missing key:iex&gt; alias Rummage.Ecto.CustomHook.KeysetPaginate iex&gt; KeysetPaginate.run(Parent, %{per_page: 10}) ** (RuntimeError) Error in params, No values given for keys: page, last_seen_pk, pkWhen a valid map of params is passed with an Ecto.Schema module:iex&gt; alias Rummage.Ecto.CustomHook.KeysetPaginate iex&gt; params = %{per_page: 10, page: 1, last_seen_pk: 0, pk: :id} iex&gt; KeysetPaginate.run(Rummage.Ecto.Product, params) #Ecto.Query&lt;from p0 in Rummage.Ecto.Product, where: p0.id &gt; ^0, limit: ^10&gt;When the queryable passed is an Ecto.Query variable:iex&gt; alias Rummage.Ecto.CustomHook.KeysetPaginate iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;products&quot; #Ecto.Query&lt;from p0 in &quot;products&quot;&gt; iex&gt; params = %{per_page: 10, page: 1, last_seen_pk: 0, pk: :id} iex&gt; KeysetPaginate.run(queryable, params) #Ecto.Query&lt;from p0 in &quot;products&quot;, where: p0.id &gt; ^0, limit: ^10&gt;More examples:iex&gt; alias Rummage.Ecto.CustomHook.KeysetPaginate iex&gt; import Ecto.Query iex&gt; params = %{per_page: 5, page: 5, last_seen_pk: 25, pk: :id} iex&gt; queryable = from u in &quot;products&quot; #Ecto.Query&lt;from p0 in &quot;products&quot;&gt; iex&gt; KeysetPaginate.run(queryable, params) #Ecto.Query&lt;from p0 in &quot;products&quot;, where: p0.id &gt; ^25, limit: ^5&gt; iex&gt; alias Rummage.Ecto.CustomHook.KeysetPaginate iex&gt; import Ecto.Query iex&gt; params = %{per_page: 5, page: 1, last_seen_pk: 0, pk: :some_id} iex&gt; queryable = from u in &quot;products&quot; #Ecto.Query&lt;from p0 in &quot;products&quot;&gt; iex&gt; KeysetPaginate.run(queryable, params) #Ecto.Query&lt;from p0 in &quot;products&quot;, where: p0.some_id &gt; ^0, limit: ^5&gt;","ref":"Rummage.Ecto.CustomHook.KeysetPaginate.html#run/2","title":"Rummage.Ecto.CustomHook.KeysetPaginate.run/2","type":"function"},{"doc":"Rummage.Ecto.CustomHook.SimpleSearch is an example of a Custom Hook that comes with Rummage.Ecto.This module provides a operations that can add searching functionality to a pipeline of Ecto queries. This module works by taking fields, and search_type and search_term.This module doesn't support associations and hence is a simple alternative to Rummage's default search hook.NOTE: This module doesn't return a list of entries, but a Ecto.Query.t. This module uses Rummage.Ecto.Hook.ABOUT:Arguments:This Hook expects a queryable (an Ecto.Queryable) and search_params (a Map). The map should be in the format: %{field_name: %{search_term: true, search_type: :eq}}Details:field_name: The field name to search by.search_term: Term to compare the field_name against.search_type: Determines the kind of search to perform. If :eq, it expects the `field_name`&#39;s value to be equal to `search_term`, If `lt`, it expects it to be less than `search_term`. To see all the `search_type`s, check `Rummage.Ecto.Services.BuildSearchQuery`search_expr: This is optional. Defaults to :where. This is the way the search expression is appended to the existing query. To see all the `search_expr`s, check `Rummage.Ecto.Services.BuildSearchQuery`For example, if we want to search products with available = true, we would do the following:Rummage.Ecto.CustomHook.SimpleSearch.run(Product, %{available: %{search_type: :eq, search_term: true}})This can be used for a search with multiple fields as well. Say, we want to search for products that are available, but have a price less than 10.0.Rummage.Ecto.CustomHook.SimpleSearch.run(Product, %{available: %{search_type: :eq, search_term: true}, %{price: %{search_type: :lt, search_term: 10.0}})Assoications:This module doesn't support assocations.ASSUMPTIONS/NOTES:This Hook assumes that the searched field is a part of the schema passed as the queryable.This Hook has the default search_type of :eq.This Hook has the default search_expr of :where.USAGE:For a regular search:This returns a queryable which upon running will give a list of Parent(s) searched by ascending field_1alias Rummage.Ecto.CustomHook.SimpleSearch searched_queryable = SimpleSearch.run(Parent, %{field_1: %{search_type: :like, search_term: &quot;field_!&quot;}}}) For a case-insensitive search:This returns a queryable which upon running will give a list of Parent(s) searched by ascending case insensitive field_1.Keep in mind that case_insensitive can only be called for text fieldsalias Rummage.Ecto.CustomHook.SimpleSearch searched_queryable = SimpleSearch.run(Parent, %{field_1: %{ search_type: &quot;ilike&quot;, search_term: &quot;field_!&quot;}}}) There are many other search_types. Check out Rummage.Ecto.Services.BuildSearchQuery docs to explore more search_types.This module can be used by overriding the default module. This can be done in the following ways:In the Rummage.Ecto call:Rummage.Ecto.rummage(queryable, rummage, search: Rummage.Ecto.CustomHook.SimpleSearch) or MySchema.rummage(rummage, search: Rummage.Ecto.CustomHook.SimpleSearch)ORGlobally for all models in config.exs:config :my_app, Rummage.Ecto, search: Rummage.Ecto.CustomHook.SimpleSearchORWhen using Rummage.Ecto with an Ecto.Schema:defmodule MySchema do use Rummage.Ecto, repo: SomeRepo, search: Rummage.Ecto.CustomHook.SimpleSearch end","ref":"Rummage.Ecto.CustomHook.SimpleSearch.html","title":"Rummage.Ecto.CustomHook.SimpleSearch","type":"module"},{"doc":"Callback implementation for Rummage.Ecto.Hook.format_params/3.This function ensures that params for each field have keys assoc, search_type and search_expr which are essential for running this hook module.Examplesiex&gt; alias Rummage.Ecto.CustomHook.SimpleSearch iex&gt; SimpleSearch.format_params(Parent, %{field: %{}}, []) %{field: %{search_expr: :where, search_type: :eq}}","ref":"Rummage.Ecto.CustomHook.SimpleSearch.html#format_params/3","title":"Rummage.Ecto.CustomHook.SimpleSearch.format_params/3","type":"function"},{"doc":"This is the callback implementation of Rummage.Ecto.Hook.run/2.Builds a search Ecto.Query.t on top of a given Ecto.Query.t variable with given params.Besides an Ecto.Query.t an Ecto.Schema module can also be passed as it implements Ecto.QueryableParams is a Map, keys of which are field names which will be searched for and value corresponding to that key is a list of params for that key, which should include the keys: \#{Enum.join(@expected_keys, &quot;, &quot;)}.This function expects a search_expr, search_type. The search_term is what the field will be matched to based on the search_type and search_expr.If no search_expr is given, it defaults to where.For all search_exprs, refer to Rummage.Ecto.Services.BuildSearchQuery.For all search_types, refer to Rummage.Ecto.Services.BuildSearchQuery.If an expected key isn't given, a Runtime Error is raised.NOTE:This hook isn't responsible for doing type validations. That's the responsibility of the user sending search_term and search_type.ExamplesWhen search_params are empty, it simply returns the same queryable:iex&gt; alias Rummage.Ecto.CustomHook.SimpleSearch iex&gt; import Ecto.Query iex&gt; SimpleSearch.run(Parent, %{}) ParentWhen a non-empty map is passed as a field params, but with a missing key:iex&gt; alias Rummage.Ecto.CustomHook.SimpleSearch iex&gt; import Ecto.Query iex&gt; SimpleSearch.run(Parent, %{field: %{search_type: :eq}}) ** (RuntimeError) Error in params, No values given for keys: search_termWhen a valid map of params is passed with an Ecto.Schema module:iex&gt; alias Rummage.Ecto.CustomHook.SimpleSearch iex&gt; import Ecto.Query iex&gt; search_params = %{field1: %{ ...&gt; search_type: :like, ...&gt; search_term: &quot;field1&quot;, ...&gt; search_expr: :where}} iex&gt; SimpleSearch.run(Rummage.Ecto.Product, search_params) #Ecto.Query&lt;from p0 in subquery(from p0 in Rummage.Ecto.Product), where: like(p0.field1, ^&quot;%field1%&quot;)&gt;When a valid map of params is passed with an Ecto.Query.t:iex&gt; alias Rummage.Ecto.CustomHook.SimpleSearch iex&gt; import Ecto.Query iex&gt; search_params = %{field1: %{ ...&gt; search_type: :like, ...&gt; search_term: &quot;field1&quot;, ...&gt; search_expr: :where}} iex&gt; query = from p0 in &quot;products&quot; iex&gt; SimpleSearch.run(query, search_params) #Ecto.Query&lt;from p0 in subquery(from p0 in &quot;products&quot;), where: like(p0.field1, ^&quot;%field1%&quot;)&gt;When a valid map of params is passed with an Ecto.Query.t and :on_where:iex&gt; alias Rummage.Ecto.CustomHook.SimpleSearch iex&gt; import Ecto.Query iex&gt; search_params = %{field1: %{ ...&gt; search_type: :like, ...&gt; search_term: &quot;field1&quot;, ...&gt; search_expr: :or_where}} iex&gt; query = from p0 in &quot;products&quot; iex&gt; SimpleSearch.run(query, search_params) #Ecto.Query&lt;from p0 in subquery(from p0 in &quot;products&quot;), or_where: like(p0.field1, ^&quot;%field1%&quot;)&gt;When a valid map of params is passed with an Ecto.Query.t, searching on a boolean paramiex&gt; alias Rummage.Ecto.CustomHook.SimpleSearch iex&gt; import Ecto.Query iex&gt; search_params = %{available: %{ ...&gt; search_type: :eq, ...&gt; search_term: true, ...&gt; search_expr: :where}} iex&gt; query = from p0 in &quot;products&quot; iex&gt; SimpleSearch.run(query, search_params) #Ecto.Query&lt;from p0 in subquery(from p0 in &quot;products&quot;), where: p0.available == ^true&gt;When a valid map of params is passed with an Ecto.Query.t, searching on a float paramiex&gt; alias Rummage.Ecto.CustomHook.SimpleSearch iex&gt; import Ecto.Query iex&gt; search_params = %{price: %{ ...&gt; search_type: :gteq, ...&gt; search_term: 10.0, ...&gt; search_expr: :where}} iex&gt; query = from p0 in &quot;products&quot; iex&gt; SimpleSearch.run(query, search_params) #Ecto.Query&lt;from p0 in subquery(from p0 in &quot;products&quot;), where: p0.price &gt;= ^10.0&gt;When a valid map of params is passed with an Ecto.Query.t, searching on a boolean param, but with a wrong search_type. NOTE: This doesn't validate the search_type of search_termiex&gt; alias Rummage.Ecto.CustomHook.SimpleSearch iex&gt; import Ecto.Query iex&gt; search_params = %{available: %{ ...&gt; search_type: :ilike, ...&gt; search_term: true, ...&gt; search_expr: :where}} iex&gt; query = from p0 in &quot;products&quot; iex&gt; SimpleSearch.run(query, search_params) ** (ArgumentError) argument error","ref":"Rummage.Ecto.CustomHook.SimpleSearch.html#run/2","title":"Rummage.Ecto.CustomHook.SimpleSearch.run/2","type":"function"},{"doc":"Rummage.Ecto.CustomHook.SimpleSort is the default sort hook that comes with Rummage.Ecto.This module provides a operations that can add sorting functionality to a pipeline of Ecto queries. This module works by taking the field that should be used to order_by, order which can be asc or desc.This module doesn't support associations and hence is a simple alternative to Rummage's default search hook.NOTE: This module doesn't return a list of entries, but a Ecto.Query.t. This module uses Rummage.Ecto.Hook.ABOUT:Arguments:This Hook expects a queryable (an Ecto.Queryable) and sort_params (a Map). The map should be in the format: %{field: :field_name, order: :asc}Details:field: The field name (atom) to sorted by.order: Specifies the type of order asc or desc.ci : Case Insensitivity. Defaults to falseFor example, if we want to sort products with descending price, we would do the following:Rummage.Ecto.CustomHook.SimpleSort.run(Product, %{field: :price, order: :desc})Assoications:This module doesn't support assocations.ASSUMPTIONS/NOTES:This Hook has the default order of :asc.This Hook assumes that the searched field is a part of the schema passed as the queryable.USAGE:For a regular sort:This returns a queryable which upon running will give a list of Parent(s) sorted by ascending field_1alias Rummage.Ecto.CustomHook.SimpleSort sorted_queryable = SimpleSort.run(Parent, %{field: :name, order: :asc}})For a case-insensitive sort:This returns a queryable which upon running will give a list of Parent(s) sorted by ascending case insensitive field_1.Keep in mind that case_insensitive can only be called for text fieldsalias Rummage.Ecto.CustomHook.SimpleSort sorted_queryable = SimpleSort.run(Parent, %{field: :name, order: :asc, ci: true}})This module can be overridden with a custom module while using Rummage.Ecto in Ecto struct module.In the Ecto module:Rummage.Ecto.rummage(queryable, rummage, sort: CustomHook)ORGlobally for all models in config.exs:config :rummage_ecto, Rummage.Ecto, sort: CustomHookThe CustomHook must use Rummage.Ecto.Hook. For examples of CustomHook, check out some custom_hooks that are shipped with Rummage.Ecto: Rummage.Ecto.CustomHook.SimpleSearch, Rummage.Ecto.CustomHook.SimpleSort, Rummage.Ecto.CustomHook.SimplePaginate","ref":"Rummage.Ecto.CustomHook.SimpleSort.html","title":"Rummage.Ecto.CustomHook.SimpleSort","type":"module"},{"doc":"Callback implementation for Rummage.Ecto.Hook.format_params/3.This function ensures that params for each field have keys assoc, order1 which are essential for running this hook module.Examplesiex&gt; alias Rummage.Ecto.CustomHook.SimpleSort iex&gt; SimpleSort.format_params(Parent, %{}, []) %{order: :asc}","ref":"Rummage.Ecto.CustomHook.SimpleSort.html#format_params/3","title":"Rummage.Ecto.CustomHook.SimpleSort.format_params/3","type":"function"},{"doc":"This is the callback implementation of Rummage.Ecto.Hook.run/2.Builds a sort Ecto.Query.t on top of the given Ecto.Queryable variable using given params.Besides an Ecto.Query.t an Ecto.Schema module can also be passed as it implements Ecto.QueryableParams is a Map which is expected to have the keys field, order.This funciton expects a field atom, order which can be asc or desc, ci which is a boolean indicating the case-insensitivity.ExamplesWhen an empty map is passed as params:iex&gt; alias Rummage.Ecto.CustomHook.SimpleSort iex&gt; SimpleSort.run(Parent, %{}) ** (RuntimeError) Error in params, No values given for keys: field, orderWhen a non-empty map is passed as params, but with a missing key:iex&gt; alias Rummage.Ecto.CustomHook.SimpleSort iex&gt; SimpleSort.run(Parent, %{field: :name}) ** (RuntimeError) Error in params, No values given for keys: orderWhen a valid map of params is passed with an Ecto.Schema module:iex&gt; alias Rummage.Ecto.CustomHook.SimpleSort iex&gt; SimpleSort.run(Rummage.Ecto.Product, %{field: :name, order: :asc}) #Ecto.Query&lt;from p0 in subquery(from p0 in Rummage.Ecto.Product), order_by: [asc: p0.name]&gt;When the queryable passed is an Ecto.Query variable:iex&gt; alias Rummage.Ecto.CustomHook.SimpleSort iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;products&quot; #Ecto.Query&lt;from p0 in &quot;products&quot;&gt; iex&gt; SimpleSort.run(queryable, %{field: :name, order: :asc}) #Ecto.Query&lt;from p0 in subquery(from p0 in &quot;products&quot;), order_by: [asc: p0.name]&gt;When the queryable passed is an Ecto.Query variable, with desc order:iex&gt; alias Rummage.Ecto.CustomHook.SimpleSort iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;products&quot; #Ecto.Query&lt;from p0 in &quot;products&quot;&gt; iex&gt; SimpleSort.run(queryable, %{field: :name, order: :desc}) #Ecto.Query&lt;from p0 in subquery(from p0 in &quot;products&quot;), order_by: [desc: p0.name]&gt;When the queryable passed is an Ecto.Query variable, with ci true:iex&gt; alias Rummage.Ecto.CustomHook.SimpleSort iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;products&quot; #Ecto.Query&lt;from p0 in &quot;products&quot;&gt; iex&gt; SimpleSort.run(queryable, %{field: :name, order: :asc, ci: true}) #Ecto.Query&lt;from p0 in subquery(from p0 in &quot;products&quot;), order_by: [asc: fragment(&quot;lower(?)&quot;, p0.name)]&gt;","ref":"Rummage.Ecto.CustomHook.SimpleSort.html#run/2","title":"Rummage.Ecto.CustomHook.SimpleSort.run/2","type":"function"},{"doc":"This module defines a behaviour that Rummage.Ecto.Hooks have to follow.This module also defines a __using__ macro which mandates certain behaviours for a Hook module to follow.Native hooks that come with Rummage.Ecto follow this behaviour.Custom Search, Sort and Paginate hooks should follow this behaviour as well, in order for them to work well with Rummage.EctoUsageThis is the preferred way of creating a Custom Hook. Using Rummage.Ecto.Hook.__using__/1 macro, it can be ensured that run/2 and format_params/2 functions have been implemented.defmodule MyCustomHook do use Rummage.Ecto.Hook def run(queryable, params), do: queryable def format_params(querable, params, opts), do: params endA Custom Hook can also be created by using Rummage.Ecto.Hook @behviourdefmodule MyCustomHook do @behviour Rummage.Ecto.Hook def run(queryable, params), do: queryable def format_params(querable, params, opts), do: params end","ref":"Rummage.Ecto.Hook.html","title":"Rummage.Ecto.Hook","type":"behaviour"},{"doc":"This macro allows us to write rummage hooks in an easier way. This includes a @behaviour module attribute and defines raisable callback implementations for the hook using this module. It also makes run/2 and format_params/3 overridable and expects them to be defined in the hook.Usage:defmodule MyHook do use Rummage.Ecto.Hook def run(queryable, params), do: &quot;do something&quot; def format_params(q, params, opts), do: &quot;do something&quot; endFor a better example, check out Rummage.Ecto.Hook.Paginate or any other hooks defined in Rummage.Ecto","ref":"Rummage.Ecto.Hook.html#__using__/1","title":"Rummage.Ecto.Hook.__using__/1","type":"macro"},{"doc":"All callback invoked by Rummage.Ecto which applies a set of translations to params passed to the hook. This is responsible for making sure that the params passed to the hook's run/2 function are santized.","ref":"Rummage.Ecto.Hook.html#c:format_params/3","title":"Rummage.Ecto.Hook.format_params/3","type":"callback"},{"doc":"","ref":"Rummage.Ecto.Hook.html#get_module/1","title":"Rummage.Ecto.Hook.get_module/1","type":"function"},{"doc":"","ref":"Rummage.Ecto.Hook.html#resolve_field/2","title":"Rummage.Ecto.Hook.resolve_field/2","type":"function"},{"doc":"All callback invoked by Rummage.Ecto which applies a set of translations to an ecto query, based on operations defined in the hook.","ref":"Rummage.Ecto.Hook.html#c:run/2","title":"Rummage.Ecto.Hook.run/2","type":"callback"},{"doc":"","ref":"Rummage.Ecto.Hook.CustomPaginate.html","title":"Rummage.Ecto.Hook.CustomPaginate","type":"module"},{"doc":"Callback implementation for Rummage.Ecto.Hook.format_params/3.This function ensures that params for each field have keys assoc, order1 which are essential for running this hook module.Examplesiex&gt; alias Rummage.Ecto.Hook.CustomSort iex&gt; Sort.format_params(Parent, %{}, []) %{assoc: [], order: :asc}","ref":"Rummage.Ecto.Hook.CustomPaginate.html#format_params/3","title":"Rummage.Ecto.Hook.CustomPaginate.format_params/3","type":"function"},{"doc":"","ref":"Rummage.Ecto.Hook.CustomPaginate.html#run/2","title":"Rummage.Ecto.Hook.CustomPaginate.run/2","type":"function"},{"doc":"","ref":"Rummage.Ecto.Hook.CustomSearch.html","title":"Rummage.Ecto.Hook.CustomSearch","type":"module"},{"doc":"Callback implementation for Rummage.Ecto.Hook.format_params/3.This function ensures that params for each field have keys assoc, search_type and search_expr which are essential for running this hook module.Examplesiex&gt; alias Rummage.Ecto.Hook.CustomSearch iex&gt; Search.format_params(Parent, %{field: %{}}, []) %{field: %{assoc: [], search_expr: :where, search_type: :eq}}","ref":"Rummage.Ecto.Hook.CustomSearch.html#format_params/3","title":"Rummage.Ecto.Hook.CustomSearch.format_params/3","type":"function"},{"doc":"","ref":"Rummage.Ecto.Hook.CustomSearch.html#run/2","title":"Rummage.Ecto.Hook.CustomSearch.run/2","type":"function"},{"doc":"","ref":"Rummage.Ecto.Hook.CustomSort.html","title":"Rummage.Ecto.Hook.CustomSort","type":"module"},{"doc":"Callback implementation for Rummage.Ecto.Hook.format_params/3.This function ensures that params for each field have keys assoc, order1 which are essential for running this hook module.Examplesiex&gt; alias Rummage.Ecto.Hook.CustomSort iex&gt; Sort.format_params(Parent, %{}, []) %{assoc: [], order: :asc}","ref":"Rummage.Ecto.Hook.CustomSort.html#format_params/3","title":"Rummage.Ecto.Hook.CustomSort.format_params/3","type":"function"},{"doc":"","ref":"Rummage.Ecto.Hook.CustomSort.html#run/2","title":"Rummage.Ecto.Hook.CustomSort.run/2","type":"function"},{"doc":"Rummage.Ecto.Hook.Paginate is the default pagination hook that comes with Rummage.Ecto.This module provides a operations that can add pagination functionality to a pipeline of Ecto queries. This module works by taking a per_page, which it uses to add a limit to the query and by setting the offset using the page variable, which signifies the current page of entries to be displayed.NOTE: This module doesn't return a list of entries, but a Ecto.Query.t. This module uses Rummage.Ecto.Hook.ABOUT:Arguments:This Hook expects a queryable (an Ecto.Queryable) and paginate_params (a Map). The map should be in the format: %{per_page: 10, page: 1}Details:per_page: Specifies the entries in each page.page: Specifies the page number.For example, if we want to paginate products, we would do the following:Rummage.Ecto.Hook.Paginate.run(Product, %{per_page: 10, page: 1})ASSUMPTIONS/NOTES:NONE: This Hook should work for all the Schema types. Whether the schema has a primary_key or not, this should handle that.USAGE:To add pagination to a Ecto.Queryable, simply do the following:Rummage.Ecto.Hook.Paginate.run(queryable, %{per_page: 10, page: 2})Overriding:This module can be overridden with a custom module while using Rummage.Ecto in Ecto struct module.In the Ecto module:Rummage.Ecto.rummage(queryable, rummage, paginate: CustomHook)ORGlobally for all models in config.exs:config :rummage_ecto, Rummage.Ecto, .paginate: CustomHookThe CustomHook must use Rummage.Ecto.Hook. For examples of CustomHook, check out some custom_hooks that are shipped with Rummage.Ecto: Rummage.Ecto.CustomHook.SimpleSearch, Rummage.Ecto.CustomHook.SimpleSort, Rummage.Ecto.CustomHook.SimplePaginate","ref":"Rummage.Ecto.Hook.Paginate.html","title":"Rummage.Ecto.Hook.Paginate","type":"module"},{"doc":"Callback implementation for Rummage.Ecto.Hook.format_params/3.This function takes an Ecto.Query.t or queryable, paginate_params which will be passed to the run/2 function, but also takes a list of options, opts.The function expects opts to include a repo key which points to the Ecto.Repo which will be used to calculate the total_count and max_page for this paginate hook module.ExamplesWhen a repo isn't passed in opts it gives an error:iex&gt; alias Rummage.Ecto.Hook.Paginate iex&gt; alias Rummage.Ecto.Category iex&gt; Paginate.format_params(Category, %{per_page: 1, page: 1}, []) ** (RuntimeError) Expected key `repo` in `opts`, got []When paginate_params given aren't valid, it uses defaults to populate params:iex&gt; alias Rummage.Ecto.Hook.Paginate iex&gt; alias Rummage.Ecto.Category iex&gt; Ecto.Adapters.SQL.Sandbox.checkout(Rummage.Ecto.Repo) iex&gt; Paginate.format_params(Category, %{}, [repo: Rummage.Ecto.Repo]) %{max_page: 0, page: 1, per_page: 10, total_count: 0}When paginate_params and opts given are valid:iex&gt; alias Rummage.Ecto.Hook.Paginate iex&gt; alias Rummage.Ecto.Category iex&gt; paginate_params = %{ ...&gt; per_page: 1, ...&gt; page: 1 ...&gt; } iex&gt; repo = Rummage.Ecto.Repo iex&gt; Ecto.Adapters.SQL.Sandbox.checkout(repo) iex&gt; Paginate.format_params(Category, paginate_params, [repo: repo]) %{max_page: 0, page: 1, per_page: 1, total_count: 0}When paginate_params and opts given are valid:iex&gt; alias Rummage.Ecto.Hook.Paginate iex&gt; alias Rummage.Ecto.Category iex&gt; paginate_params = %{ ...&gt; per_page: 1, ...&gt; page: 1 ...&gt; } iex&gt; repo = Rummage.Ecto.Repo iex&gt; Ecto.Adapters.SQL.Sandbox.checkout(repo) iex&gt; repo.insert!(%Category{name: &quot;name&quot;}) iex&gt; repo.insert!(%Category{name: &quot;name2&quot;}) iex&gt; Paginate.format_params(Category, paginate_params, [repo: repo]) %{max_page: 2, page: 1, per_page: 1, total_count: 2}When paginate_params and opts given are valid and when the queryable passed has a primary_key defaulted to id.iex&gt; alias Rummage.Ecto.Hook.Paginate iex&gt; alias Rummage.Ecto.Category iex&gt; paginate_params = %{ ...&gt; per_page: 1, ...&gt; page: 1 ...&gt; } iex&gt; repo = Rummage.Ecto.Repo iex&gt; Ecto.Adapters.SQL.Sandbox.checkout(repo) iex&gt; repo.insert!(%Category{name: &quot;name&quot;}) iex&gt; repo.insert!(%Category{name: &quot;name2&quot;}) iex&gt; Paginate.format_params(Category, paginate_params, [repo: repo]) %{max_page: 2, page: 1, per_page: 1, total_count: 2}When paginate_params and opts given are valid and when the queryable passed has a custom primary_key.iex&gt; alias Rummage.Ecto.Hook.Paginate iex&gt; alias Rummage.Ecto.Product iex&gt; paginate_params = %{ ...&gt; per_page: 1, ...&gt; page: 1 ...&gt; } iex&gt; repo = Rummage.Ecto.Repo iex&gt; Ecto.Adapters.SQL.Sandbox.checkout(repo) iex&gt; repo.insert!(%Product{internal_code: &quot;100&quot;}) iex&gt; repo.insert!(%Product{internal_code: &quot;101&quot;}) iex&gt; Paginate.format_params(Product, paginate_params, [repo: repo]) %{max_page: 2, page: 1, per_page: 1, total_count: 2}When paginate_params and opts given are valid and when the queryable passed has a custom primary_key.iex&gt; alias Rummage.Ecto.Hook.Paginate iex&gt; alias Rummage.Ecto.Employee iex&gt; paginate_params = %{ ...&gt; per_page: 1, ...&gt; page: 1 ...&gt; } iex&gt; repo = Rummage.Ecto.Repo iex&gt; Ecto.Adapters.SQL.Sandbox.checkout(repo) iex&gt; repo.insert!(%Employee{first_name: &quot;First&quot;}) iex&gt; repo.insert!(%Employee{first_name: &quot;Second&quot;}) iex&gt; Paginate.format_params(Employee, paginate_params, [repo: repo]) %{max_page: 2, page: 1, per_page: 1, total_count: 2}When paginate_params and opts given are valid and when the queryable passed is not a Ecto.Schema module, but an Ecto.Query.t.iex&gt; alias Rummage.Ecto.Hook.Paginate iex&gt; alias Rummage.Ecto.Employee iex&gt; paginate_params = %{ ...&gt; per_page: 1, ...&gt; page: 1 ...&gt; } iex&gt; repo = Rummage.Ecto.Repo iex&gt; Ecto.Adapters.SQL.Sandbox.checkout(repo) iex&gt; repo.insert!(%Employee{first_name: &quot;First&quot;}) iex&gt; repo.insert!(%Employee{first_name: &quot;Second&quot;}) iex&gt; import Ecto.Query iex&gt; queryable = from u in Employee, where: u.first_name == &quot;First&quot; iex&gt; Paginate.format_params(queryable, paginate_params, [repo: repo]) %{max_page: 1, page: 1, per_page: 1, total_count: 1}","ref":"Rummage.Ecto.Hook.Paginate.html#format_params/3","title":"Rummage.Ecto.Hook.Paginate.format_params/3","type":"function"},{"doc":"This is the callback implementation of Rummage.Ecto.Hook.run/2.Builds a paginate Ecto.Query.t on top of a given Ecto.Query.t variable with given params.Besides an Ecto.Query.t an Ecto.Schema module can also be passed as it implements Ecto.QueryableParams is a Map which is expected to have the keys per_page, page.If an expected key isn't given, a Runtime Error is raised.ExamplesWhen an empty map is passed as params:iex&gt; alias Rummage.Ecto.Hook.Paginate iex&gt; import Ecto.Query iex&gt; Paginate.run(Parent, %{}) ** (RuntimeError) Error in params, No values given for keys: per_page, pageWhen a non-empty map is passed as params, but with a missing key:iex&gt; alias Rummage.Ecto.Hook.Paginate iex&gt; import Ecto.Query iex&gt; Paginate.run(Parent, %{per_page: 10}) ** (RuntimeError) Error in params, No values given for keys: pageWhen a valid map of params is passed with an Ecto.Schema module:iex&gt; alias Rummage.Ecto.Hook.Paginate iex&gt; import Ecto.Query iex&gt; Paginate.run(Rummage.Ecto.Product, %{per_page: 10, page: 1}) #Ecto.Query&lt;from p0 in Rummage.Ecto.Product, limit: ^10, offset: ^0&gt;When the queryable passed is an Ecto.Query variable:iex&gt; alias Rummage.Ecto.Hook.Paginate iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;products&quot; #Ecto.Query&lt;from p0 in &quot;products&quot;&gt; iex&gt; Paginate.run(queryable, %{per_page: 10, page: 2}) #Ecto.Query&lt;from p0 in &quot;products&quot;, limit: ^10, offset: ^10&gt;More examples:iex&gt; alias Rummage.Ecto.Hook.Paginate iex&gt; import Ecto.Query iex&gt; rummage = %{per_page: 1, page: 1} iex&gt; queryable = from u in &quot;products&quot; #Ecto.Query&lt;from p0 in &quot;products&quot;&gt; iex&gt; Paginate.run(queryable, rummage) #Ecto.Query&lt;from p0 in &quot;products&quot;, limit: ^1, offset: ^0&gt; iex&gt; alias Rummage.Ecto.Hook.Paginate iex&gt; import Ecto.Query iex&gt; rummage = %{per_page: 5, page: 2} iex&gt; queryable = from u in &quot;products&quot; #Ecto.Query&lt;from p0 in &quot;products&quot;&gt; iex&gt; Paginate.run(queryable, rummage) #Ecto.Query&lt;from p0 in &quot;products&quot;, limit: ^5, offset: ^5&gt;","ref":"Rummage.Ecto.Hook.Paginate.html#run/2","title":"Rummage.Ecto.Hook.Paginate.run/2","type":"function"},{"doc":"Rummage.Ecto.Hook.Search is the default search hook that comes with Rummage.Ecto.This module provides a operations that can add searching functionality to a pipeline of Ecto queries. This module works by taking fields, and search_type, search_term and assoc associated with those fields.NOTE: This module doesn't return a list of entries, but a Ecto.Query.t. This module uses Rummage.Ecto.Hook.ABOUT:Arguments:This Hook expects a queryable (an Ecto.Queryable) and search_params (a Map). The map should be in the format: %{field_name: %{assoc: [], search_term: true, search_type: :eq}}Details:field_name: The field name to search by.assoc: List of associations in the search.search_term: Term to compare the field_name against.search_type: Determines the kind of search to perform. If :eq, it expects the `field_name`&#39;s value to be equal to `search_term`, If `lt`, it expects it to be less than `search_term`. To see all the `search_type`s, check `Rummage.Ecto.Services.BuildSearchQuery`search_expr: This is optional. Defaults to :where. This is the way current search expression is appended to the existing query. To see all the `search_expr`s, check `Rummage.Ecto.Services.BuildSearchQuery`For example, if we want to search products with available = true, we would do the following:Rummage.Ecto.Hook.Search.run(Product, %{available: %{assoc: [], search_type: :eq, search_term: true}})This can be used for a search with multiple fields as well. Say, we want to search for products that are available, but have a price less than 10.0.Rummage.Ecto.Hook.Search.run(Product, %{available: %{assoc: [], search_type: :eq, search_term: true}, %{price: %{assoc: [], search_type: :lt, search_term: 10.0}})Assoications:Assocaitions can be given to this module's run function as a key corresponding to params associated with a field. For example, if we want to search products that belong to a category with category_name, &quot;super&quot;, we would do the following:category_name_params = %{assoc: [inner: :category], search_term: &quot;super&quot;, search_type: :eq, search_expr: :where} Rummage.Ecto.Hook.Search.run(Product, %{category_name: category_name_params})The above operation will return an Ecto.Query.t struct which represents a query equivalent to:from p0 in Product |&gt; join(:inner, :category) |&gt; where([p, c], c.category_name == ^&quot;super&quot;)ASSUMPTIONS/NOTES:This Hook has the default search_type of :ilike, which is case-insensitive.This Hook has the default search_expr of :where.This Hook assumes that the field passed is a field on the Ecto.Schema that corresponds to the last association in the assoc list or the Ecto.Schema that corresponds to the from in queryable, if assoc is an empty list.NOTE: It is adviced to not use multiple associated searches in one operation as assoc still has some minor bugs when used with multiple searches. If you need to use two searches with associations, I would pipe the call to another search operation:Search.run(queryable, %{field1: %{assoc: [inner: :some_assoc]}} |&gt; Search.run(%{field2: %{assoc: [inner: :some_assoc2]}}USAGE:For a regular search:This returns a queryable which upon running will give a list of Parent(s) searched by ascending field_1alias Rummage.Ecto.Hook.Search searched_queryable = Search.run(Parent, %{field_1: %{assoc: [], search_type: :like, search_term: &quot;field_!&quot;}}}) For a case-insensitive search:This returns a queryable which upon running will give a list of Parent(s) searched by ascending case insensitive field_1.Keep in mind that case_insensitive can only be called for text fieldsalias Rummage.Ecto.Hook.Search searched_queryable = Search.run(Parent, %{field_1: %{assoc: [], search_type: :ilike, search_term: &quot;field_!&quot;}}}) There are many other search_types. Check out Rummage.Ecto.Services.BuildSearchQuery docs to explore more search_typesThis module can be overridden with a custom module while using Rummage.Ecto in Ecto struct module:In the Ecto module:Rummage.Ecto.rummage(queryable, rummage, search: CustomHook)ORGlobally for all models in config.exs:config :my_app, Rummage.Ecto, .search: CustomHookThe CustomHook must use Rummage.Ecto.Hook. For examples of CustomHook, check out some custom_hooks that are shipped with Rummage.Ecto: Rummage.Ecto.CustomHook.SimpleSearch, Rummage.Ecto.CustomHook.SimpleSort, Rummage.Ecto.CustomHook.SimplePaginate","ref":"Rummage.Ecto.Hook.Search.html","title":"Rummage.Ecto.Hook.Search","type":"module"},{"doc":"Callback implementation for Rummage.Ecto.Hook.format_params/3.This function ensures that params for each field have keys assoc, search_type and search_expr which are essential for running this hook module.Examplesiex&gt; alias Rummage.Ecto.Hook.Search iex&gt; Search.format_params(Parent, %{field: %{}}, []) %{field: %{assoc: [], search_expr: :where, search_type: :eq}} iex&gt; alias Rummage.Ecto.Hook.Search iex&gt; Search.format_params(Parent, %{field: 1}, []) ** (RuntimeError) No scope `field` of type search defined in the Elixir.Parent","ref":"Rummage.Ecto.Hook.Search.html#format_params/3","title":"Rummage.Ecto.Hook.Search.format_params/3","type":"function"},{"doc":"This is the callback implementation of Rummage.Ecto.Hook.run/2.Builds a search Ecto.Query.t on top of a given Ecto.Query.t variable with given params.Besides an Ecto.Query.t an Ecto.Schema module can also be passed as it implements Ecto.QueryableParams is a Map, keys of which are field names which will be searched for and value corresponding to that key is a list of params for that key, which should include the keys: \#{Enum.join(@expected_keys, &quot;, &quot;)}.This function expects a search_expr, search_type and a list of associations (empty for none). The search_term is what the field will be matched to based on the search_type and search_expr.If no search_expr is given, it defaults to where.For all search_exprs, refer to Rummage.Ecto.Services.BuildSearchQuery.For all search_types, refer to Rummage.Ecto.Services.BuildSearchQuery.If an expected key isn't given, a Runtime Error is raised.NOTE:This hook isn't responsible for doing type validations. That's the responsibility of the user sending search_term and search_type. Same goes for the validity of assoc.ExamplesWhen search_params are empty, it simply returns the same queryable:iex&gt; alias Rummage.Ecto.Hook.Search iex&gt; import Ecto.Query iex&gt; Search.run(Parent, %{}) ParentWhen a non-empty map is passed as a field params, but with a missing key:iex&gt; alias Rummage.Ecto.Hook.Search iex&gt; import Ecto.Query iex&gt; Search.run(Parent, %{field: %{assoc: []}}) ** (RuntimeError) Error in params, No values given for keys: search_type, search_termWhen a valid map of params is passed with an Ecto.Schema module:iex&gt; alias Rummage.Ecto.Hook.Search iex&gt; import Ecto.Query iex&gt; search_params = %{field1: %{assoc: [], ...&gt; search_type: :like, search_term: &quot;field1&quot;, search_expr: :where}} iex&gt; Search.run(Rummage.Ecto.Product, search_params) #Ecto.Query&lt;from p0 in subquery(from p0 in Rummage.Ecto.Product), where: like(p0.field1, ^&quot;%field1%&quot;)&gt;When a valid map of params is passed with an Ecto.Query.t:iex&gt; alias Rummage.Ecto.Hook.Search iex&gt; import Ecto.Query iex&gt; search_params = %{field1: %{assoc: [], ...&gt; search_type: :like, search_term: &quot;field1&quot;, search_expr: :where}} iex&gt; query = from p0 in &quot;products&quot; iex&gt; Search.run(query, search_params) #Ecto.Query&lt;from p0 in subquery(from p0 in &quot;products&quot;), where: like(p0.field1, ^&quot;%field1%&quot;)&gt;When a valid map of params is passed with an Ecto.Query.t, with assocs:iex&gt; alias Rummage.Ecto.Hook.Search iex&gt; import Ecto.Query iex&gt; search_params = %{field1: %{assoc: [inner: :category], ...&gt; search_type: :like, search_term: &quot;field1&quot;, search_expr: :or_where}} iex&gt; query = from p0 in &quot;products&quot; iex&gt; Search.run(query, search_params) #Ecto.Query&lt;from p0 in subquery(from p0 in &quot;products&quot;), join: c1 in assoc(p0, :category), or_where: like(c1.field1, ^&quot;%field1%&quot;)&gt;When a valid map of params is passed with an Ecto.Query.t, with assocs, with different join types:iex&gt; alias Rummage.Ecto.Hook.Search iex&gt; import Ecto.Query iex&gt; search_params = %{field1: %{assoc: [inner: :category, left: :category, cross: :category], ...&gt; search_type: :like, search_term: &quot;field1&quot;, search_expr: :where}} iex&gt; query = from p0 in &quot;products&quot; iex&gt; Search.run(query, search_params) #Ecto.Query&lt;from p0 in subquery(from p0 in &quot;products&quot;), join: c1 in assoc(p0, :category), left_join: c2 in assoc(c1, :category), cross_join: c3 in assoc(c2, :category), where: like(c3.field1, ^&quot;%field1%&quot;)&gt;When a valid map of params is passed with an Ecto.Query.t, searching on a boolean paramiex&gt; alias Rummage.Ecto.Hook.Search iex&gt; import Ecto.Query iex&gt; search_params = %{available: %{assoc: [], ...&gt; search_type: :eq, search_term: true, search_expr: :where}} iex&gt; query = from p0 in &quot;products&quot; iex&gt; Search.run(query, search_params) #Ecto.Query&lt;from p0 in subquery(from p0 in &quot;products&quot;), where: p0.available == ^true&gt;When a valid map of params is passed with an Ecto.Query.t, searching on a float paramiex&gt; alias Rummage.Ecto.Hook.Search iex&gt; import Ecto.Query iex&gt; search_params = %{price: %{assoc: [], ...&gt; search_type: :gteq, search_term: 10.0, search_expr: :where}} iex&gt; query = from p0 in &quot;products&quot; iex&gt; Search.run(query, search_params) #Ecto.Query&lt;from p0 in subquery(from p0 in &quot;products&quot;), where: p0.price &gt;= ^10.0&gt;When a valid map of params is passed with an Ecto.Query.t, searching on a boolean param, but with a wrong search_type. NOTE: This doesn't validate the search_type of search_termiex&gt; alias Rummage.Ecto.Hook.Search iex&gt; import Ecto.Query iex&gt; search_params = %{available: %{assoc: [], ...&gt; search_type: :ilike, search_term: true, search_expr: :where}} iex&gt; query = from p0 in &quot;products&quot; iex&gt; Search.run(query, search_params) ** (ArgumentError) argument error","ref":"Rummage.Ecto.Hook.Search.html#run/2","title":"Rummage.Ecto.Hook.Search.run/2","type":"function"},{"doc":"Rummage.Ecto.Hook.Sort is the default sort hook that comes with Rummage.Ecto.This module provides a operations that can add sorting functionality to a pipeline of Ecto queries. This module works by taking the field that should be used to order_by, order which can be asc or desc and assoc, which is a keyword list of assocations associated with those fields.NOTE: This module doesn't return a list of entries, but a Ecto.Query.t. This module uses Rummage.Ecto.Hook.ABOUT:Arguments:This Hook expects a queryable (an Ecto.Queryable) and sort_params (a Map). The map should be in the format: %{field: :field_name, assoc: [], order: :asc}Details:field: The field name (atom) to sorted by.assoc: List of associations in the sort.order: Specifies the type of order asc or desc.ci : Case Insensitivity. Defaults to falseFor example, if we want to sort products with descending price, we would do the following:Rummage.Ecto.Hook.Sort.run(Product, %{field: :price, assoc: [], order: :desc})Assoications:Assocaitions can be given to this module's run function as a key corresponding to params associated with a field. For example, if we want to sort products that belong to a category by ascending category_name, we would do the following:params = %{field: :category_name, assoc: [inner: :category], order: :asc} Rummage.Ecto.Hook.Sort.run(Product, params)The above operation will return an Ecto.Query.t struct which represents a query equivalent to:from p0 in Product |&gt; join(:inner, :category) |&gt; order_by([p, c], {asc, c.category_name})ASSUMPTIONS/NOTES:This Hook has the default order of :asc.This Hook has the default assoc of [].This Hook assumes that the field passed is a field on the Ecto.Schema that corresponds to the last association in the assoc list or the Ecto.Schema that corresponds to the from in queryable, if assoc is an empty list.NOTE: It is adviced to not use multiple associated sorts in one operation as assoc still has some minor bugs when used with multiple sorts. If you need to use two sorts with associations, I would pipe the call to another sort operation:Sort.run(queryable, params1} |&gt; Sort.run(%{field2: params2}USAGE:For a regular sort:This returns a queryable which upon running will give a list of Parent(s) sorted by ascending field_1alias Rummage.Ecto.Hook.Sort sorted_queryable = Sort.run(Parent, %{assoc: [], field: :name, order: :asc}})For a case-insensitive sort:This returns a queryable which upon running will give a list of Parent(s) sorted by ascending case insensitive field_1.Keep in mind that case_insensitive can only be called for text fieldsalias Rummage.Ecto.Hook.Sort sorted_queryable = Sort.run(Parent, %{assoc: [], field: :name, order: :asc, ci: true}})This module can be overridden with a custom module while using Rummage.Ecto in Ecto struct module.In the Ecto module:Rummage.Ecto.rummage(queryable, rummage, sort: CustomHook)ORGlobally for all models in config.exs:config :rummage_ecto, Rummage.Ecto, sort: CustomHookThe CustomHook must use Rummage.Ecto.Hook. For examples of CustomHook, check out some custom_hooks that are shipped with Rummage.Ecto: Rummage.Ecto.CustomHook.SimpleSearch, Rummage.Ecto.CustomHook.SimpleSort, Rummage.Ecto.CustomHook.SimplePaginate","ref":"Rummage.Ecto.Hook.Sort.html","title":"Rummage.Ecto.Hook.Sort","type":"module"},{"doc":"Callback implementation for Rummage.Ecto.Hook.format_params/3.This function ensures that params for each field have keys assoc, order1 which are essential for running this hook module.Examplesiex&gt; alias Rummage.Ecto.Hook.Sort iex&gt; Sort.format_params(Parent, %{}, []) %{assoc: [], order: :asc}","ref":"Rummage.Ecto.Hook.Sort.html#format_params/3","title":"Rummage.Ecto.Hook.Sort.format_params/3","type":"function"},{"doc":"This is the callback implementation of Rummage.Ecto.Hook.run/2.Builds a sort Ecto.Query.t on top of the given Ecto.Queryable variable using given params.Besides an Ecto.Query.t an Ecto.Schema module can also be passed as it implements Ecto.QueryableParams is a Map which is expected to have the keys field, order, assoc.This funciton expects a field atom, order which can be asc or desc, ci which is a boolean indicating the case-insensitivity and assoc which is a list of associations with their join types.ExamplesWhen an empty map is passed as params:iex&gt; alias Rummage.Ecto.Hook.Sort iex&gt; Sort.run(Parent, %{}) ** (RuntimeError) Error in params, No values given for keys: field, order, assocWhen a non-empty map is passed as params, but with a missing key:iex&gt; alias Rummage.Ecto.Hook.Sort iex&gt; Sort.run(Parent, %{field: :name}) ** (RuntimeError) Error in params, No values given for keys: order, assocWhen a valid map of params is passed with an Ecto.Schema module:iex&gt; alias Rummage.Ecto.Hook.Sort iex&gt; Sort.run(Rummage.Ecto.Product, %{field: :name, assoc: [], order: :asc}) #Ecto.Query&lt;from p0 in subquery(from p0 in Rummage.Ecto.Product), order_by: [asc: p0.name]&gt;When the queryable passed is an Ecto.Query variable:iex&gt; alias Rummage.Ecto.Hook.Sort iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;products&quot; #Ecto.Query&lt;from p0 in &quot;products&quot;&gt; iex&gt; Sort.run(queryable, %{field: :name, assoc: [], order: :asc}) #Ecto.Query&lt;from p0 in subquery(from p0 in &quot;products&quot;), order_by: [asc: p0.name]&gt;When the queryable passed is an Ecto.Query variable, with desc order:iex&gt; alias Rummage.Ecto.Hook.Sort iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;products&quot; #Ecto.Query&lt;from p0 in &quot;products&quot;&gt; iex&gt; Sort.run(queryable, %{field: :name, assoc: [], order: :desc}) #Ecto.Query&lt;from p0 in subquery(from p0 in &quot;products&quot;), order_by: [desc: p0.name]&gt;When the queryable passed is an Ecto.Query variable, with ci true:iex&gt; alias Rummage.Ecto.Hook.Sort iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;products&quot; #Ecto.Query&lt;from p0 in &quot;products&quot;&gt; iex&gt; Sort.run(queryable, %{field: :name, assoc: [], order: :asc, ci: true}) #Ecto.Query&lt;from p0 in subquery(from p0 in &quot;products&quot;), order_by: [asc: fragment(&quot;lower(?)&quot;, p0.name)]&gt;When the queryable passed is an Ecto.Query variable, with associations:iex&gt; alias Rummage.Ecto.Hook.Sort iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;products&quot; #Ecto.Query&lt;from p0 in &quot;products&quot;&gt; iex&gt; Sort.run(queryable, %{field: :name, assoc: [inner: :category, left: :category], order: :asc}) #Ecto.Query&lt;from p0 in subquery(from p0 in &quot;products&quot;), join: c1 in assoc(p0, :category), left_join: c2 in assoc(c1, :category), order_by: [asc: c2.name]&gt;When the queryable passed is an Ecto.Schema module with associations, desc order and ci true:iex&gt; alias Rummage.Ecto.Hook.Sort iex&gt; queryable = Rummage.Ecto.Product Rummage.Ecto.Product iex&gt; Sort.run(queryable, %{field: :name, assoc: [inner: :category], order: :desc, ci: true}) #Ecto.Query&lt;from p0 in subquery(from p0 in Rummage.Ecto.Product), join: c1 in assoc(p0, :category), order_by: [desc: fragment(&quot;lower(?)&quot;, c1.name)]&gt;","ref":"Rummage.Ecto.Hook.Sort.html#run/2","title":"Rummage.Ecto.Hook.Sort.run/2","type":"function"},{"doc":"","ref":"Rummage.Ecto.QueryUtils.html","title":"Rummage.Ecto.QueryUtils","type":"module"},{"doc":"","ref":"Rummage.Ecto.QueryUtils.html#schema_from_query/1","title":"Rummage.Ecto.QueryUtils.schema_from_query/1","type":"function"},{"doc":"This module is meant to be used by a module (typically an Ecto.Schema).This isn't a required module for using Rummage, but it allows us to extend its functionality.","ref":"Rummage.Ecto.Schema.html","title":"Rummage.Ecto.Schema","type":"module"},{"doc":"This macro allows us to leverage features in Rummage.Ecto.Schema. It takes advantage of Ecto, rummage_field and rummage_scopeUsage:defmodule MySchema do use Rummage.Ecto.Schema schema &quot;my_table&quot; do field :field1, :integer field :field2, :integer timestamps() end rummage_field :field1_or_field2 do {:fragment, &quot;coalesce(?, ?)&quot;, :name, :description} end rummage_scope :show_page, [type: :paginate], fn(page) -&gt; %{per_page: 10, page: page} end end","ref":"Rummage.Ecto.Schema.html#__using__/1","title":"Rummage.Ecto.Schema.__using__/1","type":"macro"},{"doc":"Rummage Field is a way to define a field which can be used to search, sort, paginate through. This field might not exist in the database or the schema, but can be represented as a fragments query using multiple fields.NOTE: Currently this feature has some limitations due to limitations put on Ecto's fragments. Ecto 3.0 is expected to come out with unsafe_fragment, which will give this feature great flexibility. This feature is also quite dependent on what database engine is being used. For now, we have made a few fragments available (the list can be seen here) which are thoroughly tested on postgres. If these fragments don't do it, you can use rummage_scope to accomplish a similar functionality.Usage:To use upper case name as rummage field:rummage_field :upper_case_name do {:fragment, &quot;upper(?)&quot;, :name} endTo use the hour for created_at as rummage field:rummage_field :created_at_hour do {:fragment, &quot;date_part(&#39;hour&#39;, ?)&quot;, :inserted_at} end","ref":"Rummage.Ecto.Schema.html#rummage_field/2","title":"Rummage.Ecto.Schema.rummage_field/2","type":"macro"},{"doc":"","ref":"Rummage.Ecto.Schema.html#rummage_scope/3","title":"Rummage.Ecto.Schema.rummage_scope/3","type":"macro"},{"doc":"Usage:defmodule MyApp.Rummage.MyModel do use Rummage.Schema, paginate: MyApp.Rummage.Paginate, sort: MyApp.Rummage.MyModel.Sort, search: MyApp.Rummage.MyModel.Search, schema: MyApp.MyModel end","ref":"Rummage.Ecto.Schema.Macro.html","title":"Rummage.Ecto.Schema.Macro","type":"module"},{"doc":"Usage:defmodule MyApp.Rummage.Paginate do use Rummage.Schema.Paginate end","ref":"Rummage.Ecto.Schema.Paginate.html","title":"Rummage.Ecto.Schema.Paginate","type":"module"},{"doc":"Usage:defmodule MyApp.Rummage.MyModel.Search do use Rummage.Schema.Search, handlers: [ category_name: %{search_field: :name, search_type: :ilike, assoc: [inner: :category]}, price_gteq: %{search_field: :price, search_type: :gteq}, price_lteq: %{search_field: :price, search_type: :lteq}, name: %{search_type: :ilike}, month: :integer, year: :integer, ] # Skip blank searches def search(query, name, nil), do: query def search(query, name, &quot;&quot;), do: query def search(query, :month, month) do from p in query, where: fragment(&quot;date_part(&#39;month&#39;, ?)&quot;, p.inserted_at) == ^month end def search(query, :year, year) do from p in query, where: fragment(&quot;date_part(&#39;year&#39;, ?)&quot;, p.inserted_at) == ^year end # Because we&#39;re overriding search we need to call super... def search(query, name, value) do super(query, name, value) end end","ref":"Rummage.Ecto.Schema.Search.html","title":"Rummage.Ecto.Schema.Search","type":"module"},{"doc":"Usage:defmodule MyApp.Rummage.MyModel.Sort do use Rummage.Schema.Sort, default_name: &quot;inserted_at&quot;, handlers: [ category_name: %{field: :name, assoc: [inner: :category], ci: true}, name: %{ci: true}, price: %{}, ] # Custom handlers... def sort(query, &quot;inserted_at&quot;, order) do order = String.to_atom(order) from p in query, order_by: [ {^order, p.inserted_at}, {^order, p.id} ] end # Because we&#39;re overriding sort we need to call super... def sort(query, name, order) do super(query, name, order) end end","ref":"Rummage.Ecto.Schema.Sort.html","title":"Rummage.Ecto.Schema.Sort","type":"module"},{"doc":"Rummage.Ecto.Services.BuildSearchQuery is a service module which serves the default search hook, Rummage.Ecto.Hook.Search that comes shipped with Rummage.Ecto.Module Attributes@search_types ~w{like ilike eq gt lt gteq lteq is_nil}a @search_exprs ~w{where or_where not_where}a@search_types is a collection of all the 8 valid search_types that come shipped with Rummage.Ecto's default search hook. The types are:like: Searches for a term in a given field of a queryable.ilike: Searches for a term in a given field of a queryable, in a case insensitive fashion.eq: Searches for a term to be equal to a given field of a queryable.gt: Searches for a term to be greater than to a given field of a queryable.lt: Searches for a term to be less than to a given field of a queryable.gteq: Searches for a term to be greater than or equal to to a given field of a queryable.lteq: Searches for a term to be less than or equal to a given field of a queryable.is_nil: Searches for a null value when term is true, or not null when term is false.in: Searches for a given field in a collection of terms in a queryable.@search_exprs is a collection of 3 valid search_exprs that are used to apply a search_type to a Ecto.Queryable. Those expressions are:where (DEFAULT): An AND where query expression.or_where: An OR where query expression. Behaves exactly like where but combines the previous expression with an `OR` operation. Useful for optional searches.not_where: A NOT where query expression. This can be used while excluding a list of entries based on where query.Feel free to use this module on a custom search hook that you write.","ref":"Rummage.Ecto.Services.BuildSearchQuery.html","title":"Rummage.Ecto.Services.BuildSearchQuery","type":"module"},{"doc":"Builds a searched queryable on top of the given queryable using field, search_term and search_expr when the search_type is eq.Assumes that search_expr is in [:where, :or_where, :not_where].ExamplesWhen search_expr is :whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_eq(queryable, :field_1, &quot;field_!&quot;, :where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 == ^&quot;field_!&quot;&gt;When search_expr is :or_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_eq(queryable, :field_1, &quot;field_!&quot;, :or_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: p0.field_1 == ^&quot;field_!&quot;&gt;When search_expr is :not_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_eq(queryable, :field_1, &quot;field_!&quot;, :not_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 != ^&quot;field_!&quot;&gt;","ref":"Rummage.Ecto.Services.BuildSearchQuery.html#handle_eq/4","title":"Rummage.Ecto.Services.BuildSearchQuery.handle_eq/4","type":"function"},{"doc":"Builds a searched queryable on top of the given queryable using field, search_term and search_expr when the search_type is gt.Assumes that search_expr is in [:where, :or_where, :not_where].ExamplesWhen search_expr is :whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_gt(queryable, :field_1, &quot;field_!&quot;, :where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 &gt; ^&quot;field_!&quot;&gt;When search_expr is :or_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_gt(queryable, :field_1, &quot;field_!&quot;, :or_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: p0.field_1 &gt; ^&quot;field_!&quot;&gt;When search_expr is :not_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_gt(queryable, :field_1, &quot;field_!&quot;, :not_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 &lt;= ^&quot;field_!&quot;&gt;","ref":"Rummage.Ecto.Services.BuildSearchQuery.html#handle_gt/4","title":"Rummage.Ecto.Services.BuildSearchQuery.handle_gt/4","type":"function"},{"doc":"Builds a searched queryable on top of the given queryable using field, search_term and search_expr when the search_type is gteq.Assumes that search_expr is in [:where, :or_where, :not_where].ExamplesWhen search_expr is :whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_gteq(queryable, :field_1, &quot;field_!&quot;, :where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 &gt;= ^&quot;field_!&quot;&gt;When search_expr is :or_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_gteq(queryable, :field_1, &quot;field_!&quot;, :or_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: p0.field_1 &gt;= ^&quot;field_!&quot;&gt;When search_expr is :not_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_gteq(queryable, :field_1, &quot;field_!&quot;, :not_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 &lt; ^&quot;field_!&quot;&gt;","ref":"Rummage.Ecto.Services.BuildSearchQuery.html#handle_gteq/4","title":"Rummage.Ecto.Services.BuildSearchQuery.handle_gteq/4","type":"function"},{"doc":"Builds a searched queryable on top of the given queryable using field, search_term and search_expr when the search_type is ilike.Checkout Ecto.Query.API.ilike/2 for more info.Assumes that search_expr is in [:where, :or_where, :not_where].ExamplesWhen search_expr is :whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_ilike(queryable, :field_1, &quot;field_!&quot;, :where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: ilike(p0.field_1, ^&quot;%field_!%&quot;)&gt;When search_expr is :or_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_ilike(queryable, :field_1, &quot;field_!&quot;, :or_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: ilike(p0.field_1, ^&quot;%field_!%&quot;)&gt;When search_expr is :not_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_ilike(queryable, :field_1, &quot;field_!&quot;, :not_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: not(ilike(p0.field_1, ^&quot;%field_!%&quot;))&gt;","ref":"Rummage.Ecto.Services.BuildSearchQuery.html#handle_ilike/4","title":"Rummage.Ecto.Services.BuildSearchQuery.handle_ilike/4","type":"function"},{"doc":"Builds a searched queryable on field based on whether it exists in a given collection, based on search_expr given.Checkout Ecto.Query.API.in/2 for more info.Assumes that search_expr is in [:where, :or_where, :not_where].ExamplesWhen search_expr is :whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_in(queryable, :field_1, [&quot;a&quot;, &quot;b&quot;], :where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 in ^[&quot;a&quot;, &quot;b&quot;]&gt;When search_expr is :or_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_in(queryable, :field_1, [&quot;a&quot;, &quot;b&quot;], :or_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: p0.field_1 in ^[&quot;a&quot;, &quot;b&quot;]&gt;When search_expr is :not_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_in(queryable, :field_1, [&quot;a&quot;, &quot;b&quot;], :not_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 not in ^[&quot;a&quot;, &quot;b&quot;]&gt;","ref":"Rummage.Ecto.Services.BuildSearchQuery.html#handle_in/4","title":"Rummage.Ecto.Services.BuildSearchQuery.handle_in/4","type":"function"},{"doc":"Builds a searched queryable on field is_nil (when term is true), or not is_nil (when term is false), based on search_expr given.Checkout Ecto.Query.API.like/2 for more info.Assumes that search_expr is in [:where, :or_where, :not_where].ExamplesWhen search_expr is :whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_is_nil(queryable, :field_1, true, :where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: is_nil(p0.field_1)&gt; iex&gt; BuildSearchQuery.handle_is_nil(queryable, :field_1, false, :where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: not(is_nil(p0.field_1))&gt;When search_expr is :or_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_is_nil(queryable, :field_1, true, :or_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: is_nil(p0.field_1)&gt; iex&gt; BuildSearchQuery.handle_is_nil(queryable, :field_1, false, :or_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: not(is_nil(p0.field_1))&gt;When search_expr is :not_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_is_nil(queryable, :field_1, true, :not_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: not(is_nil(p0.field_1))&gt; iex&gt; BuildSearchQuery.handle_is_nil(queryable, :field_1, false, :not_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: is_nil(p0.field_1)&gt;","ref":"Rummage.Ecto.Services.BuildSearchQuery.html#handle_is_nil/4","title":"Rummage.Ecto.Services.BuildSearchQuery.handle_is_nil/4","type":"function"},{"doc":"Builds a searched queryable on top of the given queryable using field, search_term and search_expr when the search_type is like.Checkout Ecto.Query.API.like/2 for more info.NOTE: Be careful of Like InjectionsAssumes that search_expr is in [:where, :or_where, :not_where].ExamplesWhen search_expr is :whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_like(queryable, :field_1, &quot;field_!&quot;, :where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: like(p0.field_1, ^&quot;%field_!%&quot;)&gt;When search_expr is :or_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_like(queryable, :field_1, &quot;field_!&quot;, :or_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: like(p0.field_1, ^&quot;%field_!%&quot;)&gt;When search_expr is :not_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_like(queryable, :field_1, &quot;field_!&quot;, :not_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: not(like(p0.field_1, ^&quot;%field_!%&quot;))&gt;","ref":"Rummage.Ecto.Services.BuildSearchQuery.html#handle_like/4","title":"Rummage.Ecto.Services.BuildSearchQuery.handle_like/4","type":"function"},{"doc":"Builds a searched queryable on top of the given queryable using field, search_term and search_expr when the search_type is lt.Assumes that search_expr is in [:where, :or_where, :not_where].ExamplesWhen search_expr is :whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_lt(queryable, :field_1, &quot;field_!&quot;, :where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 &lt; ^&quot;field_!&quot;&gt;When search_expr is :or_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_lt(queryable, :field_1, &quot;field_!&quot;, :or_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: p0.field_1 &lt; ^&quot;field_!&quot;&gt;When search_expr is :not_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_lt(queryable, :field_1, &quot;field_!&quot;, :not_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 &gt;= ^&quot;field_!&quot;&gt;","ref":"Rummage.Ecto.Services.BuildSearchQuery.html#handle_lt/4","title":"Rummage.Ecto.Services.BuildSearchQuery.handle_lt/4","type":"function"},{"doc":"Builds a searched queryable on top of the given queryable using field, search_term and search_expr when the search_type is lteq.Assumes that search_expr is in [:where, :or_where, :not_where].ExamplesWhen search_expr is :whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_lteq(queryable, :field_1, &quot;field_!&quot;, :where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 &lt;= ^&quot;field_!&quot;&gt;When search_expr is :or_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_lteq(queryable, :field_1, &quot;field_!&quot;, :or_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: p0.field_1 &lt;= ^&quot;field_!&quot;&gt;When search_expr is :not_whereiex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.handle_lteq(queryable, :field_1, &quot;field_!&quot;, :not_where) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 &gt; ^&quot;field_!&quot;&gt;","ref":"Rummage.Ecto.Services.BuildSearchQuery.html#handle_lteq/4","title":"Rummage.Ecto.Services.BuildSearchQuery.handle_lteq/4","type":"function"},{"doc":"Builds a searched queryable on top of the given queryable using field, search_type and search_term.ExamplesWhen search_type is where: When field, search_type and queryable are passed with search_type of like: iex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.run(queryable, :field_1, {:where, :like}, &quot;field_!&quot;) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: like(p0.field_1, ^&quot;%field_!%&quot;)&gt; When field, search_type and queryable are passed with search_type of ilike: iex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.run(queryable, :field_1, {:where, :ilike}, &quot;field_!&quot;) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: ilike(p0.field_1, ^&quot;%field_!%&quot;)&gt; When field, search_type and queryable are passed with search_type of eq: iex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.run(queryable, :field_1, {:where, :eq}, &quot;field_!&quot;) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 == ^&quot;field_!&quot;&gt; When field, search_type and queryable are passed with search_type of gt: iex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.run(queryable, :field_1, {:where, :gt}, &quot;field_!&quot;) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 &gt; ^&quot;field_!&quot;&gt; When field, search_type and queryable are passed with search_type of lt: iex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.run(queryable, :field_1, {:where, :lt}, &quot;field_!&quot;) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 &lt; ^&quot;field_!&quot;&gt; When field, search_type and queryable are passed with search_type of gteq: iex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.run(queryable, :field_1, {:where, :gteq}, &quot;field_!&quot;) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 &gt;= ^&quot;field_!&quot;&gt; When field, search_type and queryable are passed with search_type of lteq: iex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.run(queryable, :field_1, {:where, :lteq}, &quot;field_!&quot;) #Ecto.Query&lt;from p0 in &quot;parents&quot;, where: p0.field_1 &lt;= ^&quot;field_!&quot;&gt;When search_type is or_where:When field, search_type and queryable are passed with search_type of like: iex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.run(queryable, :field_1, {:or_where, :like}, &quot;field_!&quot;) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: like(p0.field_1, ^&quot;%field_!%&quot;)&gt;When field, search_type and queryable are passed with search_type of ilike: iex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.run(queryable, :field_1, {:or_where, :ilike}, &quot;field_!&quot;) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: ilike(p0.field_1, ^&quot;%field_!%&quot;)&gt;When field, search_type and queryable are passed with search_type of eq: iex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.run(queryable, :field_1, {:or_where, :eq}, &quot;field_!&quot;) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: p0.field_1 == ^&quot;field_!&quot;&gt;When field, search_type and queryable are passed with search_type of gt: iex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.run(queryable, :field_1, {:or_where, :gt}, &quot;field_!&quot;) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: p0.field_1 &gt; ^&quot;field_!&quot;&gt;When field, search_type and queryable are passed with search_type of lt: iex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.run(queryable, :field_1, {:or_where, :lt}, &quot;field_!&quot;) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: p0.field_1 &lt; ^&quot;field_!&quot;&gt;When field, search_type and queryable are passed with search_type of gteq: iex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.run(queryable, :field_1, {:or_where, :gteq}, &quot;field_!&quot;) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: p0.field_1 &gt;= ^&quot;field_!&quot;&gt;When field, search_type and queryable are passed with search_type of lteq: iex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.run(queryable, :field_1, {:or_where, :lteq}, &quot;field_!&quot;) #Ecto.Query&lt;from p0 in &quot;parents&quot;, or_where: p0.field_1 &lt;= ^&quot;field_!&quot;&gt;When field, search_type and queryable are passed with an invalid search_type and search_expr: iex&gt; alias Rummage.Ecto.Services.BuildSearchQuery iex&gt; import Ecto.Query iex&gt; queryable = from u in &quot;parents&quot; #Ecto.Query&lt;from p0 in &quot;parents&quot;&gt; iex&gt; BuildSearchQuery.run(queryable, :field_1, {:pizza, :cheese}, &quot;field_!&quot;) ** (RuntimeError) Unknown {search_expr, search_type}, {:pizza, :cheese} search_type should be one of [:like, :ilike, :eq, :gt, :lt, :gteq, :lteq, :is_nil, :in] search_expr should be one of [:where, :or_where, :not_where]","ref":"Rummage.Ecto.Services.BuildSearchQuery.html#run/4","title":"Rummage.Ecto.Services.BuildSearchQuery.run/4","type":"function"},{"doc":"TODO: Finish","ref":"Rummage.Ecto.Services.BuildSearchQuery.html#t:search_expr/0","title":"Rummage.Ecto.Services.BuildSearchQuery.search_expr/0","type":"type"},{"doc":"TODO: Finish","ref":"Rummage.Ecto.Services.BuildSearchQuery.html#t:search_type/0","title":"Rummage.Ecto.Services.BuildSearchQuery.search_type/0","type":"type"},{"doc":"Rummage.Ecto If you're looking for full Phoenix support, Rummage.Phoenix uses Rummage.Ecto and adds HTML and Controller support to it. You can check Rummage.Phoenix out by clicking herePlease refer for CHANGELOG for version specific changesRummage.Ecto is a light weight, but powerful framework that can be used to alter Ecto queries with Search, Sort and Paginate operations.It accomplishes the above operations by using Hooks, which are modules that implement Rummage.Ecto.Hook behavior. Each operation: Search, Sort and Paginate have their hooks defined in Rummage. By doing this, Rummage is completely configurable.For example, if you don't like one of the hooks of Rummage, but you do like the other two, you can configure Rummage to not use it and write your own custom hook.NOTE: Rummage is not like Ransack, and it doesn't intend to be like Ransack. It doesn't define functions based on search parameters. If you'd like to have something like that, you can always configure Rummage to use your Search module for that model. This is why Rummage has been made configurable.To see an example usage of rummage, check this repository.","ref":"readme.html","title":"Rummage.Ecto","type":"extras"},{"doc":"This package is available in Hex, and can be installed as:Add rummage_ecto to your list of dependencies in mix.exs:def deps do [{:rummage_ecto, &quot;~&gt; 2.0.0-rc.0&quot;}] end","ref":"readme.html#installation","title":"Rummage.Ecto - Installation","type":"extras"},{"doc":"Current Blogs:Rummage Demo &amp; BasicsUsing Rummage.EctoUsing Rummage.Phoenix: Part 1Coming up next:Using Rummage.Phoenix: Part 2Using the Rummage Search hookUsing the Rummage Sort hookWriting a Custom Rummage.Ecto HookWriting a Custom Rummage.Phoenix HTML helper","ref":"readme.html#blogs","title":"Rummage.Ecto - Blogs","type":"extras"},{"doc":"Hooks are modules (that use Rummage.Ecto.Hook) and implement callbacks for Rummage.Ecto.Hook behaviour. Each ecto operation which can transform the query is defined by a Hook. Hooks have run/2 function using which they can transform an Ecto.Queryable variable and have format_params/3 function using which they can transform params passed to them through rummage_ecto","ref":"readme.html#hooks","title":"Rummage.Ecto - Hooks","type":"extras"},{"doc":"NOTE: This is Optional. If no configuration is provided, Rummage will use default hooks and AppName.Repo as the repoIf you want to override any of the Rummage default hooks, add rummage_ecto config to your list of configs in dev.exs:config :rummage_ecto, Rummage.Ecto, search: MyApp.SearchModuleFor configuring a repo:config :rummage_ecto, Rummage.Ecto, repo: MyApp.Repo # This can be overridden per model basis, if need be.Other config options are: repo, sort, paginate, per_pageRummage.Ecto can be configured globally with a per_page value (which can be overridden for a model). If you want to set different per_page for different the models, add it to model.exs file while using Rummage.Ecto as shown in the Advanced Usage Section.","ref":"readme.html#configuration","title":"Rummage.Ecto - Configuration","type":"extras"},{"doc":"Rummage.Ecto comes with a lot of powerful features which are available right away, without writing a whole lot of code.Below are the ways Rummage.Ecto can be used:Basic Usage:Add the Repo of your app and the desired per_page (if using Rummage's Pagination) to the rummage_ecto configuration in config.exs: config :rummage_ecto, Rummage.Ecto, repo: MyApp.Repo, per_page: 10And you should be able to use Rummage.Ecto with any Ecto model.Advanced Usage:If you'd like to override any of Rummage's default hooks with your custom hook, add the CustomHook of your app with the desired operation to the rummage_ecto configuration in config.exs: config :rummage_ecto, Rummage.Ecto, repo: MyApp.Repo, search: MyApp.SearchModule, paginate: MyApp.PaginateModuleWhen using Rummage.Ecto with an app that has multiple Repos, or when there's a need to configure Repo per model basis, it can be passed along with with the call to Rummage.Ecto. This overrides the default repo set in the configuration: {queryable, rummage} = Product |&gt; Rummage.Ecto.rummage(rummage, repo: MyApp.Repo2)And you should be able to use Rummage.Ecto with Product model which is in a different Repo than the default one.","ref":"readme.html#usage","title":"Rummage.Ecto - Usage","type":"extras"},{"doc":"Setting up the application above will allow us to do the following: rummage = %{ search: %{field_1 =&gt; %{search_type: :like, search_term: &quot;field_!&quot;}}, sort: %{field: :field1, order: :asc}, paginate: %{per_page: 5, page: 1} } {queryable, rummage} = Product |&gt; Rummage.Ecto.rummage(rummage) products = queryable |&gt; Product.another_operation # &lt;-- Since `Rummage` is Ecto, we can pipe the result queryable into another queryable operation. |&gt; Repo.allRummage responds to params with keys: search, sort and/or paginate. It doesn't need to have all the keys, or any keys for that matter. If invalid keys are passed, they won't alter any operations in rummage. Here's an example of Rummage params: rummage = %{ search: %{field_1 =&gt; %{search_type: :like, search_term: &quot;field_!&quot;}}, sort: %{field: :field1, order: :asc}, paginate: %{per_page: 5, page: 1} }","ref":"readme.html#examples","title":"Rummage.Ecto - Examples","type":"extras"},{"doc":"Versions CHANGELOG","ref":"changelog.html","title":"Versions CHANGELOG","type":"extras"},{"doc":"Change in namespace/module names:Replace Rummage.Ecto.Hooks with Rummage.Ecto.Hook.Replace Rummage.Ecto.CustomHooks with Rummage.Ecto.CustomHook.Introducing Rummage.Ecto.Schema:Changes to Rummage.Ecto.Hook.Search:Changes to Rummage.Ecto.Hook.Sort:Changes to Rummage.Ecto.Hook.Paginate:Changes in Configurations:","ref":"changelog.html#version-2-0-0-rc-0","title":"Versions CHANGELOG - Version 2.0.0-rc.0","type":"extras"},{"doc":"Better Behaviour definition for Hooks.Add __using__ macro, instead of using module_attribute @behviour.Use better function names run/2 and format_params,Use defoverridable for @behaviour callbacks.Make Native hooks more generalized instead of targeted for phoenix.Use atoms over strings for keys in maps and params.Keep hooks more agnostic of configurations.Make Rummage.Ecto delegate configurations to hooks.The return of Rummage.Ecto.__using__/1 macro.This allows rummage_ecto to resolve configurations at compile time.This allows better/easier usage of Rummage.Ecto.App specific configurations.config :appname, Rummage.Ecto ..... instead of config: :rummage_ecto, Rummage.Ecto. This allows using rummage with two different apps in an umbrella app with different rummage configurations.These configurations are loaded with the help of __using__ macro, based on the application the module belongs to.Search hook has search_expr.This allows usage of or_where and not_where queries.Defaults to where.Search hook has search_type : is_nilThis allows for searching for NULL or NOT NULLTested/Examples with different field_types, boolean, float, string etc.Paginate hook works with or without a primary_key:the default paginate hook used to work only for Schemas with id as primary keys, now it works for all and even Schemas without a primary key.Keyset Pagination CustomHook.Adds faster/lighter weight pagination option.Documentation specifies when to use it and when not to.SimpleSort and SimpleSearch CustomHook updates.Same as sort and search, but without associations, so cleaner and faster.Better documentation.Search and Sort associations are better documented.CustomHooks are better documented.","ref":"changelog.html#version-1-3-0-rc-0","title":"Versions CHANGELOG - Version: 1.3.0-rc.0","type":"extras"},{"doc":"Faster Pagination Hooks","ref":"changelog.html#version-1-2-0","title":"Versions CHANGELOG - Version: 1.2.0","type":"extras"},{"doc":"Changes to Rummage as whole:More functional way of calling Rummage:Instead of EctoSchema.rummage(query, rummage), call Rummage.Ecto.rummage(query, rummage)Default Hooks can handle any number of associations.Changes to complexity:Hooks are more independent of each other due to a newly introduced before_hook feature. This allows us to format rummage_params based on what a hook is expecting and keep the code clean.In Progress:A CustomHook with key-set pagination based on this link.","ref":"changelog.html#version-1-1-0","title":"Versions CHANGELOG - Version: 1.1.0","type":"extras"},{"doc":"Major changes to default hooks:Search:Can now search more than just like.Added case insensitive like feature.Added support for like, ilike, eq, gt, lt, gteq, lteq as search_types (Refer to docs for more details)Can search on an association field (Refer to docs for more details)Sort:Added case insensitive sort.Can sort on an association field (Refer to docs for more details)Pagination: NO CHANGESChange in rummage struct syntaxes:search key:Earlier:rummage = %{&quot;search&quot; =&gt; %{&quot;field_1&quot; =&gt; &quot;field_!&quot;}}Now:rummage = %{&quot;search&quot; =&gt; %{&quot;field_1&quot; =&gt; %{&quot;assoc&quot; =&gt; [&quot;assoc_1&quot;, &quot;assoc_2&quot;], &quot;search_type&quot; =&gt; &quot;like&quot;, &quot;search_term&quot; =&gt; &quot;field_!&quot;}}sort key:Earlier:rummage = %{&quot;sort&quot; =&gt; &quot;field_1.asc&quot;}Now:rummage = %{&quot;sort&quot; =&gt; %{&quot;assoc&quot; =&gt; [&quot;assoc_1&quot;, &quot;assoc_2&quot;], &quot;field&quot; =&gt; &quot;field_1.asc&quot;}}paginate key: NO CHANGESCustom Hooks Examples Included:Included some examples for custom hooks:Rumamage.Ecto.CustomHooks.SimpleSearch: Vanilla search feature with support for only likeRumamage.Ecto.CustomHooks.SimpleSort: Vanilla sort feature","ref":"changelog.html#version-1-0-0","title":"Versions CHANGELOG - Version: 1.0.0","type":"extras"},{"doc":"First version with Rummage.Phoenix compatibilityFirst major version","ref":"changelog.html#version-0-6-0","title":"Versions CHANGELOG - Version: 0.6.0","type":"extras"},{"doc":"NomenclatureWork in Progress","ref":"nomenclature.html","title":"Nomenclature","type":"extras"},{"doc":"WalkthroughWork in Progress","ref":"walkthrough.html","title":"Walkthrough","type":"extras"}]